Page MenuHomePhabricator

Improve reviewer experience when multiple users simultaneously review Pending Changes
Closed, ResolvedPublic

Description

When multiple users review the same article at the same time (as frequently occurs), there are a number of things that can be frustrating:

  • One person accepts the changes hastily, while another is still carefully reading
  • An article can be advertised as "under review" merely because the reviewer is looking at the "review" link

More info can be found here (under "Review conflict"):
http://en.wikipedia.org/wiki/Wikipedia:Pending_changes/Feedback/Archive_4#Succinct_yet_descriptive_list_of_issues_and_suggestions


Version: unspecified
Severity: enhancement

Details

Reference
bz25295

Event Timeline

bzimport raised the priority of this task from to Normal.Nov 21 2014, 11:16 PM
bzimport set Reference to bz25295.
bzimport added a subscriber: Unknown Object (MLST).

Adding Brandon to the cc line.

Quoting the relevant portion of this email:
http://lists.wikimedia.org/pipermail/wikitech-l/2010-October/049813.html

Almost everyone who I've talked to about this problem feels like maybe
the timeout needs to be tuned, but since almost no one knows what the
timeout is, that may be the problem itself.

One possible workflow (inspired by our conversation, but not vetted by
Brandon or Alolita) is this:

  • On the list of pages to review, keep the "under review" notice

pretty much exactly as is

  • On the review page, in the "Review this revision" box, put one of

two notices:

  • "This page is being reviewed by User:Xyz, who started 20:09, 7 October 2010"
  • "You are being advertised as currently reviewing of this page

(started 20:09, 7 October 2010). [Stop reviewing]"

This would add some transparency to the review process, which will
help us tune the timeout and generally make this work more as people
would expect it to.

Some implementation questions that we didn't know the answers to:

  1. Do we know *who* is doing the reviewing of a page? (i.e. is this

already stored somewhere we can get at it easily) If so, the notice
should be pretty straightforward.

  1. If so, when *anyone* looks at a set of pending changes, does it

mark it as "under review"? We're assuming not, but one thing that's
frustrating is that any time a reviewer looks at a diff, that
automatically puts the page "under review".

aaron added a comment.Dec 20 2010, 9:56 PM
  1. We don't know who is reviewing it.
  2. It marks the page under review if any Reviewer looks at it now, atm.

I suppose a new table will be needed with oldid,newid,userid,exptime columns.

aaron added a comment.Mar 20 2011, 2:44 PM

Tracking of user/startime and review form notices added in r84383. This still uses memcached for performance and only one person can be marked as reviewing something.

aaron added a comment.Mar 23 2011, 6:41 PM

(In reply to comment #2)

  • On the review page, in the "Review this revision" box, put one of

two notices:

  • "This page is being reviewed by User:Xyz, who started 20:09, 7 October

2010"

  • "You are being advertised as currently reviewing of this page

(started 20:09, 7 October 2010). [Stop reviewing]"

How would [stop reviewing] work? AJAX? Would it act as a back button or just leave the user there?

Perhaps we can broaded the scope of this bug to the MediaWiki component.

A mediawiki core table for 'activity' usable by core and extensions as well.

Could by used by other stuff as well such as:

aaron added a comment.Apr 17 2011, 7:18 PM

(In reply to comment #7)

Perhaps we can broaded the scope of this bug to the MediaWiki component.
A mediawiki core table for 'activity' usable by core and extensions as well.
Could by used by other stuff as well such as:

http://www.mediawiki.org/wiki/Extension:Ajax_Show_Editors

I'd have a branch with an activity table but shelved it since I wasn't sure about hitting the master for this kind of stuff.

(In reply to comment #5)

Tracking of user/startime and review form notices added in r84383. This still
uses memcached for performance and only one person can be marked as reviewing
something.

To be clear, the "This page is being reviewed" message is there, but not the "You are being advertised" one yet.

aaron added a comment.Jun 14 2011, 3:44 AM

(In reply to comment #9)

(In reply to comment #5)

Tracking of user/startime and review form notices added in r84383. This still
uses memcached for performance and only one person can be marked as reviewing
something.

To be clear, the "This page is being reviewed" message is there, but not the
"You are being advertised" one yet.

Added in r90033.